PGREP(1)

NOM
pgrep, pkill - Rechercher ou envoyer un signal à des processus en fonction de leur nom et d'autres propriétés

SYNOPSIS
pgrep [options] motif
pkill [options] motif

DESCRIPTION
pgrep parcourt les processus en cours d'exécution et affiche sur la sortie standard les identifiants des processus qui correspondent aux critères de sélection donnés. Tous les critères doivent correspondre. Par exemple :

    $ pgrep -u root sshd

n'affichera que les processus appelés sshd ET qui appartiennent à root. En revanche,

    $ pgrep -u root,daemon

affichera les processus appartenant à root OU à daemon.

pkill enverra le signal indiqué (SIGTERM par défaut) à chaque processus au lieu de les afficher sur la sortie standard.

OPTIONS

-signal
--signal signal
    Indiquer le signal à envoyer à chaque processus sélectionné. Le signal peut être indiqué par son numéro ou par son nom symbolique (seulement pour pkill).

-c, --count
    À la place de la sortie normale, afficher le nombre de processus correspondant aux critères. S'il n'y a pas de correspondance, c'est-à-dire si zéro est renvoyé, la commande renverra une valeur non nulle.

-d, --delimiter délimiteur
    Déterminer la chaîne utilisée pour délimiter les PID en sortie (un saut de ligne par défaut) (seulement pour pgrep).

-f, --full
    Le motif n'est normalement comparé qu'au nom du processus. Avec -f, la ligne de commande complète est utilisée.

-g, --pgroup pgrp,...
    Ne rechercher que des processus dans les groupes de processus donnés. Le groupe de processus 0 se traduit par le propre groupe de processus de pgrep ou pkill.

-G, --group gid,...
    Ne rechercher que des processus dont l'identifiant de groupe réel est donné. Les valeurs utilisées peuvent être numériques ou symboliques.

-i, --ignore-case
    Match processes case-insensitively.

-l, --list-name
    Afficher le nom du processus avec le PID (seulement pour pgrep).

-a, --list-full
    Afficher la ligne de commande complète avec le PID (seulement pour pgrep).

-n, --newest
    Ne sélectionner que le processus correspondant le plus récent.

-o, --oldest
    Ne sélectionner que le processus correspondant le plus ancien.

-P, --parent ppid,...
    Ne sélectionner que les processus dont le PID parent est donné.

-s, --session sid,...
    Ne sélectionner que les processus dont l'identifiant de session est donné. La session 0 se traduit par le propre identifiant de session de pgrep ou pkill.

-t, --terminal term,...
    Ne sélectionner que les processus dont le terminal de contrôle est donné. Le nom du terminal doit être indiqué sans le préfixe « /dev/ ».

-u, --euid euid,...
    Ne sélectionner que les processus dont l'UID effectif est donné. La valeur utilisée peut être numérique ou symbolique.

-U, --uid uid,...
    Ne sélectionner que les processus dont l'UID réel est donné. La valeur utilisée peut être numérique ou symbolique.

-v, --inverse
    Inverser la sélection. Cette option est normalement utilisée dans le contexte de pgrep. Dans le contexte de pkill, l'option courte est désactivée pour éviter qu'elle soit utilisée par accident.

-w, --lightweight
    Montrer tous les identifiants de processus légers (« threads ») au lieu des PID dans le contexte de pgrep. Dans le contexte de pkill, cette option est désactivée.

-x, --exact
    Ne sélectionner que les processus dont le nom (ou la ligne de commande si -f est utilisée) correspond exactement au motif.

-F, --pidfile fichier
    Lire les PID dans le fichier. Cette option est peut-être plus utile pour pkill que pgrep.

-L, --logpidfile
    Échouer si le fichier de PID (consultez -F) n'est pas verrouillé.

--ns PID
    Sélectionner les processus qui appartiennent aux mêmes espaces de nommage. Doit être exécuté en tant que superutilisateur pour sélectionner les processus d’autres utilisateurs. Consultez --nslist pour une manière de limiter les espaces de nommage à sélectionner.

--nslist en[,en]...
    Ne sélectionner que les espaces de nommage fournis. Les espaces de nommage disponibles sont : ipc, mnt, net, pid, user et uts.

-V, --version
    Afficher la version du logiciel et quitter.

-h, --help
    Afficher l'aide et quitter.

OPÉRANDES

motif
    Indiquer une expression rationnelle étendue utilisée pour comparer avec les noms de processus ou les lignes de commandes.

EXEMPLES
Exemple 1 : Trouver le PID du démon named :

    $ pgrep -u root named

Exemple 2 : Faire relire son fichier de configuration par syslog :

    $ pkill -HUP syslogd

Exemple 3 : Donner des informations détaillées sur tous les processus xterm :

    $ ps -fp $(pgrep -d, -x xterm)

Exemple 4 : Réduire la priorité de tous les processus netscape :

    $ renice +4 $(pgrep netscape)

CODES DE RETOUR
0   Un ou plusieurs processus correspondaient aux critères.
1   Aucun processus ne correspondait.
2   Erreur de syntaxe dans la ligne de commande.
3   Erreur fatale, par exemple plus de mémoire disponible.

NOTES
Le nom du processus utilisé pour la sélection est limité aux 15 caractères présents dans /proc/pid/stat. Utilisez l'option -f pour sélectionner en fonction de la ligne de commande complète, /proc/pid/cmdline.

Le processus pgrep ou pkill qui s'exécute ne se considérera jamais comme correspondant aux critères.

BOGUES
Les options -n, -o et -v ne peuvent pas être utilisées en même temps. Signalez-le si vous en avez besoin.

Les processus zombies sont affichés.

VOIR AUSSI
ps(1), regex(7), signal(7), killall(1), skill(1), kill(1), kill(2)

AUTEUR
Kjetil Torgrim Homme <kjetilho@ifi.uio.no>

BOGUES
Signalez les bogues à <procps@freelists.org>